---
title: DOMMatrixReadOnly
slug: Web/API/DOMMatrixReadOnly
tags:
  - 2D
  - 3D
  - API
  - Computation
  - DOMMatrixReadOnly
  - Geometry
  - Geometry Interfaces
  - Graphics
  - Interface
  - Math
  - Modeling
  - Read-only
  - Reference
  - Rotate
  - Scale
  - Skew
  - VR
  - Web
  - angle
  - camera
  - matrix
  - transform
---
<p>{{APIRef("Geometry Interfaces")}}</p>

<p><span class="seoSummary">The <code><strong>DOMMatrixReadOnly</strong></code> interface represents a read-only 4×4 matrix, suitable for 2D and 3D operations. The {{domxref("DOMMatrix")}} interrface—which is based upon <code>DOMMatrixReadOnly</code>—adds {{interwiki("wikipedia", "Immutable object", "mutability")}}, allowing you to alter the matrix after creating it.</span> A 4×4 matrix is suitable to describe any rotation and translation in 3D.</p>

<p>This interface should be available inside <a href="/en-US/docs/Web/API/Web_Workers_API">web workers</a>, though some implementations doesn't allow it yet.</p>

<h2 id="Properties">Properties</h2>

<p><em>This interface doesn't inherit any properties.</em></p>

<dl>
 <dt><code>is2D</code> {{ReadOnlyInline}}</dt>
 <dd>A Boolean flag whose value is <code>true</code> if the matrix was initialized as a 2D matrix. If <code>false</code>, the matrix is 3D.</dd>
 <dt><code>isIdentity</code> {{ReadOnlyInline}}</dt>
 <dd>A Boolean whose value is <code>true</code> if the matrix is the {{interwiki("wikipedia", "identity matrix")}}. The identity matrix is one in which every value is <code>0</code> <em>except</em> those on the main diagonal from top-left to bottom-right corner (in other words, where the offsets in each direction are equal).</dd>
 <dt><code>m11</code>, <code>m12</code>, <code>m13</code>, <code>m14</code>, <code>m21</code>, <code>m22</code>, <code>m23</code>, <code>m24</code>, <code>m31</code>, <code>m32</code>, <code>m33</code>, <code>m34</code>, <code>m41</code>, <code>m42</code>, <code>m43</code>, <code>m44</code></dt>
 <dd>Double-precision floating-point values representing each component of a 4×4 matrix, where <code>m11</code> through <code>m14</code> are the first column, <code>m21</code> through <code>m24</code> are the second column, and so forth.</dd>
 <dt><code>a</code>, <code>b</code>, <code>c</code>, <code>d</code>, <code>e</code>, <code>f</code></dt>
 <dd>
 <p>Double-precision floating-point values representing the components of a 4×4 matrix which are required in order to perform 2D rotations and translations. These are aliases for specific components of a 4×4 matrix, as shown below.</p>

 <table class="standard-table">
  <thead>
   <tr>
    <th scope="col">2D</th>
    <th scope="col">3D equivalent</th>
   </tr>
  </thead>
  <tbody>
   <tr>
    <td><code>a</code></td>
    <td><code>m11</code></td>
   </tr>
   <tr>
    <td><code>b</code></td>
    <td><code>m12</code></td>
   </tr>
   <tr>
    <td><code>c</code></td>
    <td><code>m21</code></td>
   </tr>
   <tr>
    <td><code>d</code></td>
    <td><code>m22</code></td>
   </tr>
   <tr>
    <td><code>e</code></td>
    <td><code>m41</code></td>
   </tr>
   <tr>
    <td><code>f</code></td>
    <td><code>m42</code></td>
   </tr>
  </tbody>
 </table>
 </dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface doesn't inherit any methods. None of the following methods alter the original matrix.</em></p>

<dl>
 <dt>{{domxref("DOMMatrixReadOnly.flipX()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by flipping the source matrix around its X-axis. This is equivalent to multiplying the matrix by  <code>DOMMatrix(-1, 0, 0, 1, 0, 0)</code>. The original matrix is not modified.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.flipY()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by flipping the source matrix around its Y-axis. This is equivalent to multiplying the matrix by  <code>DOMMatrix(1, 0, 0, -1, 0, 0)</code>. The original matrix is not modified.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.inverse()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by inverting the source matrix. If the matrix cannot be inverted, the new matrix's components are all set to <code>NaN</code> and its <code>is2D</code> property is set to <code>false</code>. The original matrix is not altered.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.multiply()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by computing the dot product of the source matrix and the specified matrix: <code><var>A</var>⋅<var>B</var></code>. If no matrix is specified as the multiplier, the matrix is multiplied by a matrix in which every element is <code>0</code> <em>except</em> the bottom-right corner and the element immediately above and to its left: <code>m<sub>33</sub></code> and <code>m<sub>34</sub></code>. These have the default value of <code>1</code>. The original matrix is not modified.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.rotateAxisAngle()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by rotating the source matrix by the given angle around the specified vector. The original matrix is not modified.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.rotate()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by rotating the source matrix around each of its axes by the specified number of degrees. The original matrix is not altered.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.rotateFromVector()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by rotating the source matrix by the angle between the specified vector and <code>(1, 0)</code>. The original matrix is not modified.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.scale()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by scaling the source matrix by the amount specified for each axis, centered on the given origin. By default, the X and Z axes are scaled by <code>1</code> and the Y axis has no default scaling value. The default origin is <code>(0, 0, 0)</code>. The original matrix is not modified.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.scale3d()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by scaling the source 3D matrix by the given factor along all its axes, centered on the specified origin point. The default origin is <code>(0, 0, 0)</code>. The original matrix is not modified.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.scaleNonUniform()")}} {{obsolete_inline}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by applying the specified scaling on the X, Y, and Z axes, centered at the given origin. By default, the Y and Z axes' scaling factors are both <code>1</code>, but the scaling factor for X must be specified. The default origin is <code>(0, 0, 0)</code>. The original matrix is not changed.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.skewX()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by applying the specified skew transformation to the source matrix along its X-axis. The original matrix is not modified.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.skewY()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} created by applying the specified skew transformation to the source matrix along its Y-axis. The original matrix is not modified.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.toFloat32Array()")}}</dt>
 <dd>Returns a new {{jsxref("Float32Array")}} containing all 16 elements (<code>m11</code>, <code>m12</code>, <code>m13</code>, <code>m14</code>, <code>m21</code>, <code>m22</code>, <code>m23</code>, <code>m24</code>, <code>m31</code>, <code>m32</code>, <code>m33</code>, <code>m34</code>, <code>m41</code>, <code>m42</code>, <code>m43</code>, <code>m44</code>) which comprise the matrix. The elements are stored into the array as single-precision floating-point numbers in column-major (colexographical access, or "colex") order. (In other words, down the first column from top to bottom, then the second column, and so forth.)</dd>
 <dt>{{domxref("DOMMatrixReadOnly.toFloat64Array()")}}</dt>
 <dd>Returns a new {{jsxref("Float64Array")}} containing all 16 elements (<code>m11</code>, <code>m12</code>, <code>m13</code>, <code>m14</code>, <code>m21</code>, <code>m22</code>, <code>m23</code>, <code>m24</code>, <code>m31</code>, <code>m32</code>, <code>m33</code>, <code>m34</code>, <code>m41</code>, <code>m42</code>, <code>m43</code>, <code>m44</code>) which comprise the matrix. The elements are stored into the array as double-precision floating-point numbers in column-major (colexographical access access or "colex") order. (In other words, down the first column from top to bottom, then the second column, and so forth.)</dd>
 <dt>{{domxref("DOMMatrixReadOnly.toJSON()")}}</dt>
 <dd>Returns a JSON representation of the <code>DOMMatrixReadOnly</code> object.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.toString()")}}</dt>
 <dd>
 <p>Creates and returns a {{domxref("DOMString")}} object which contains a string representation of the matrix in CSS matrix syntax, using the appropriate CSS matrix notation. See the {{cssxref("matrix()")}} CSS function for details on this syntax. </p>

 <p>For a 2D matrix, the elements <code><var>a</var></code> through <code><var>f</var></code> are listed, for a total of six values and the form <code>matrix(<var>a</var>, <var>b</var>, <var>c</var>, <var>d</var>, <var>e</var>, <var>f</var>)</code>.</p>

 <p>For a 3D matrix, the returned string contains all 16 elements and takes the form <code>matrix3d(<var>m<sub>11</sub></var>, <var>m<sub>12</sub></var>, <var>m<sub>13</sub></var>, <var>m<sub>14</sub></var>, <var>m<sub>21</sub></var>, <var>m<sub>22</sub></var>, <var>m<sub>23</sub></var>, <var>m<sub>24</sub></var>, <var>m<sub>31</sub></var>, <var>m<sub>32</sub></var>, <var>m<sub>33</sub></var>, <var>m<sub>34</sub></var>, <var>m<sub>41</sub></var>, <var>m<sub>42</sub></var>, <var>m<sub>43</sub></var>, <var>m<sub>44</sub></var>)</code>. See the CSS {{cssxref("matrix3d()")}} function for details on the 3D notation's syntax.</p>

 <p>Throws an <code>InvalidStateError</code> exception if any of the elements in the matrix are non-finite (even if, in the case of a 2D matrix, the non-finite values are in elements not used by the 2D matrix representation).</p>
 </dd>
 <dt>{{domxref("DOMMatrixReadOnly.transformPoint()")}}</dt>
 <dd>Transforms the specified point using the matrix, returning a new {{domxref("DOMPoint")}} object containing the transformed point. Neither the matrix nor the original point are altered.</dd>
 <dt>{{domxref("DOMMatrixReadOnly.translate()")}}</dt>
 <dd>Returns a new {{domxref("DOMMatrix")}} containing a matrix calculated by translating the source matrix using the specified vector. By default, the vector is <code>(0, 0, 0)</code>. The original matrix is not changed.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<p><em>This interface inherits methods from {{domxref("DOMMatrixReadOnly")}}.</em></p>

<dl>
 <dt>{{domxref("DOMMatrix.fromFloat32Array", "fromFloat32Array()")}}</dt>
 <dd>Creates a new mutable <code>DOMMatrix</code> object given an array of single-precision (32-bit) floating-point values. If the array has six values, the result is a 2D matrix; if the array has 16 values, the result is a 3D matrix. Otherwise, a <code>TypeError</code> exception is thrown.</dd>
 <dt>{{domxref("DOMMatrix.fromFloat64Array", "fromFloat64Array()")}}</dt>
 <dd>Creates a new mutable <code>DOMMatrix</code> object given an array of double-precision (64-bit) floating-point values. If the array has six values, the result is a 2D matrix; if the array has 16 values, the result is a 3D matrix. Otherwise, a <code>TypeError</code> exception is thrown.</dd>
 <dt>{{domxref("DOMMatrix.fromMatrix", "fromMatrix()")}}</dt>
 <dd>Creates a new mutable <code>DOMMatrix</code> object given an existing matrix or a {{domxref("DOMMatrixInit")}} dictionary which provides the values for its properties. If no matrix is specified, the matrix is initialized with every element set to <code>0</code> <em>except</em> the bottom-right corner and the element immediately above and to its left: <code>m<sub>33</sub></code> and <code>m<sub>34</sub></code>. These have the default value of <code>1</code>.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Geometry Interfaces', '#dommatrixreadonly', 'DOMMatrixReadOnly') }}</td>
   <td>{{ Spec2('Geometry Interfaces') }}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DOMMatrixReadOnly")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The mutable matrix type, {{domxref("DOMMatrix")}}, which is based on this one.</li>
 <li>{{domxref("SVGMatrix")}} and {{domxref("CSSMatrix")}}, the {{Glossary("SVG")}} and {{Glossary("CSS")}} specific types that should be getting replaced by this interface.</li>
 <li>The CSS {{cssxref("transform-function", "matrix()", "#matrix()")}} and {{cssxref("transform-function", "matrix3d()", "#matrix3d()")}} functional notation that can be generated from this interface to be used in a CSS {{cssxref("transform")}}.</li>
</ul>
